<?php
global $currentPrivateWhoisStatus;
global $emailFwdList;
global $urlFwdList;
global $dnsList;

//sample DomainMain
if($isidn and $idnname != ""){
	$realdomain = $idnname;
}else{
	$realdomain = $cSld;
}

//domain variables are stored in $this_dom_config
//to view: var_dump($this_dom_config);




if($action=="adddnsrecord")	{
	
	// Check if user press back button
	if(isset($_REQUEST['btnBack']))	{
		$_REQUEST['plugin_mode'] = null;	
	} else {
	
		include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
		$domainName = $cSld.'.'.$cTld;
	
		$dnsFullRecordName = strtolower(trim($_REQUEST['dnsFullRecordName']));
		$dnsType           = strtolower(trim($_REQUEST['dnsType']));
		$dnsValue          = strtolower(trim($_REQUEST['dnsValue']));
		$dnsTtl            = strtolower(trim($_REQUEST['dnsTtl']));
		$dnsPriority       = strtolower(trim($_REQUEST['dnsPriority']));
		
		// Check if some value provided
		if($dnsValue == '')	{
			$dmsg = generate_dmsg("Invalid data","error");
		} else {
			// Make sure that we add ns to correct domain 
			$dnsFullRecordName = strtolower(trim($dnsFullRecordName.'.'.$domainName,'. '));
	
			$params = array(
				'FullRecordName'        => $dnsFullRecordName,
				'Type'                  => $dnsType,
				'Value'                 => $dnsValue,
				'Ttl'                   => $dnsTtl,
				'this_registrar_config' => $this_registrar_config,
			);

			if($dnsType == 'mx')	{
				$params['Priority'] = $dnsPriority;	
			}
		
			eval ('$return = ' . $registrar . '_adddnsrecord($params);');
	
			if($return["status"]=="2"){
				$dmsg = generate_dmsg($return['response_text'],"error");
			}else{
				$dmsg = generate_dmsg('DNS record has been added',"success");
			}
		}
	}
}

if($action=="addurlfwdrule")	{
	
	// Check if user press back button
	if(isset($_REQUEST['btnBack']))	{
		$_REQUEST['plugin_mode'] = null;	
	} else {
	
		include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
		$domainName = $cSld.'.'.$cTld;
	
		$source          = strtolower(trim($_REQUEST['fwdSiteSource']));
		$destination     = strtolower(trim($_REQUEST['fwdSiteDestination']));
		$isFramed        = strtolower(trim($_REQUEST['fwdUseFrame']));
		$siteTitle       = strtolower(trim($_REQUEST['fwdSiteTitle']));
		$metaDescription = strtolower(trim($_REQUEST['fwdSiteDescription']));
		$metaKeywords    = strtolower(trim($_REQUEST['fwdSiteKeywords']));

		if($destination == '')	{
			$dmsg = generate_dmsg('Invalid value for "To Address"',"error");
		} else {
			// Make sure that we add ns to correct domain 
			$source = strtolower(trim($source.'.'.$domainName,'. '));
	
			$params = array(
				'source'                => $source,
				'destination'           => $destination,
				'isFramed'              => $isFramed,
				'this_registrar_config' => $this_registrar_config,
			);

			if(strlen($siteTitle))	{
				$params['siteTitle'] = $siteTitle;
			}
	
			if(strlen($metaDescription))	{
				$params['metaDescription'] = $metaDescription;
			}
	
			if(strlen($metaKeywords))	{
				$params['metaKeywords'] = $metaKeywords;
			}
	
	
			eval ('$return = ' . $registrar . '_addurlfwd($params);');
	
			if($return["status"]=="2"){
				$dmsg = generate_dmsg($return['response_text'],"error");
			}else{
				$dmsg = generate_dmsg('URL forward rule has been added',"success");
			}
		}
		
	}
}

if($action=="remdnsrecord")	{
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	$fullRecordName = strtolower(trim($_REQUEST['fwdFullRecordName']));

	// Check if user try to delete url fwd rule for domain which belong to him  
	if(preg_match('/(^|\.)'.preg_quote($domainName).'$/i', $fullRecordName))	{
		$params = array(
			'FullRecordName'        => trim($fullRecordName),
			'Type'                  => trim($_REQUEST['fwdType']),
			'Value'                 => trim($_REQUEST['fwdValue']),
			'this_registrar_config' => $this_registrar_config,
		);
	
		eval ('$return = ' . $registrar . '_remdnsrecord($params);');
	
		if($return["status"]=="2"){
			$dmsg = generate_dmsg($return['response_text'],"error");
		}else{
			$dmsg = generate_dmsg('DNS record has been removed',"success");
		}
	}
}


if($action=="remeurlfwdrule")	{
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	$source = strtolower(trim($_REQUEST['fwdRuleSource']));

	// Check if user try to delete url fwd rule for domain which belong to him  
	if(preg_match('/(^|\.)'.preg_quote($domainName).'$/i', $source))	{
		$params = array(
			'source'                => trim($source),
			'this_registrar_config' => $this_registrar_config,
		);
	
		eval ('$return = ' . $registrar . '_remurlfwd($params);');
	
		if($return["status"]=="2"){
			$dmsg = generate_dmsg($return['response_text'],"error");
		}else{
			$dmsg = generate_dmsg('Email forward rule has been removed',"success");
		}
	}
}


if($action=="rememailfwdrule")	{
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	$source = strtolower(trim($_REQUEST['fwdRuleSource']));
	
	list($src, $dom) = explode('@',$source);
	$source = $src.'@'.$dom; 
	
	$params = array(
		'source'                => urlencode(trim($source)),
		'this_registrar_config' => $this_registrar_config,
	);
	
	eval ('$return = ' . $registrar . '_rememailfwd($params);');
	
	if($return["status"]=="2"){
		$dmsg = generate_dmsg($return['response_text'],"error");
	}else{
		$dmsg = generate_dmsg('Email forward rule has been removed',"success");
	}
}

if($action=="addemailfwdrule")	{
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	
	$source = strtolower(trim($_REQUEST['newFwdRuleSource']));
	$destination = strtolower(trim($_REQUEST['newFwdRuleDestination']));
	
	if($destination == '')	{
		$dmsg = generate_dmsg('Invalid value for "Destination"',"error");
	} else {
	
		$params = array(
			'source'                => urlencode(trim($source.'@'.$domainName)),
			'destination'           => trim($destination),
			'this_registrar_config' => $this_registrar_config,
		);
	
		eval ('$return = ' . $registrar . '_addemailfwd($params);');
	
		if($return["status"]=="2"){
			$dmsg = generate_dmsg($return['response_text'],"error");
		}else{
			$dmsg = generate_dmsg('Email forward rule has been added',"success");
		}
	}
}

if($action=="privatewhois")	{
	// Check if user press back button
	if(isset($_REQUEST['btnBack']))	{
		$_REQUEST['plugin_mode'] = null;	
	} else {
	
		include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
		$domainName = $cSld.'.'.$cTld;

		$privateWhoisMode = strtolower(trim($_REQUEST['privateWhoisMode']));
		$currentPrivateWhoisStatus = strtolower(trim($_REQUEST['currentPrivateWhoisStatus']));

		if($privateWhoisMode == $currentPrivateWhoisStatus)	{
			$dmsg = generate_dmsg('Private whois status has been updated',"success");
		} else {
	
			$params = array(
				'domain' => $domainName,
				'mode'   => $privateWhoisMode,
				'this_registrar_config'=>$this_registrar_config,
			);

			eval ('$return = ' . $registrar . '_privatewhois($params);');
	
			if($return["status"]=="2"){
				$dmsg = generate_dmsg('Private whois status has been updated',"success");
			}else{
				$dmsg = generate_dmsg('Failure updating private whois status',"error");
			}
		}
	}
}
$reglocked = $this_dom_config['locked'];
$autorenewflag = $this_dom_config['auto_renew'];

if($action=="setautorenew"){
	$autorenewflag1=$_POST[autorenewflag];
	$seclevel="DOMAR1";
	include($workdir."/includes/seccheck.php");
	if($autorenewflag1==""){$autorenewflag1=0;}
	$req=sqlwritesingle("UPDATE domainlist SET auto_renew='$autorenewflag1' WHERE tld='$cTld' AND sld='$realdomain'");
	$dmsg = AROK;
	$dmsg = generate_dmsg($dmsg,"success");
        $autorenewflag=$autorenewflag1;
}

if($action=="setlocking"){
	$seclevel="DOML1";
	include($workdir."/includes/seccheck.php");
	$orderid = $this_dom_config['domainid'];
	$ownerid = $this_dom_config['ownerid'];
	if($reglocker=="yes" || $reglocker=="on"){
		$params=array();
		reset($params);
		$params['this_registrar_config']=$this_registrar_config;
		$params['ownerid']=$ownerid;
		$params['cTld']=$cTld;
		$params['cSld']=$cSld;
		$params['realdomain']=$realdomain;
		$params['idn']=$idn;
		$params['idnname']=$idnname;
		$params['idndomain'] = "$idnname.$cTld";
		$params['domain']="$realdomain.$cTld";
		include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
		eval ('$result = ' . $registrar . '_lockdomain($params);');

		if($result["status"]=="2"){
			$dmsg = LOCKOK;
			$dmsg = generate_dmsg($dmsg,"success");
			$req=sqlwritesingle("UPDATE domainlist SET locked='1' WHERE tld='$cTld' AND sld='$realdomain'");
                        $reglocked="1";
		}else{
			$dmsg = "- Failure updating lock status: ".$result["response_text"]." -" ;
			$dmsg = generate_dmsg($dmsg,"error");
		}

	}else{
		$params=array();
		reset($params);
		$params['this_registrar_config']=$this_registrar_config;
		$params['ownerid']=$ownerid;
		$params['cTld']=$cTld;
		$params['cSld']=$cSld;
		$params['realdomain']=$realdomain;
		$params['idn']=$idn;
		$params['idnname']=$idnname;
		$params['idndomain'] = "$idnname.$cTld";
		$params['domain']="$realdomain.$cTld";
		include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
		eval ('$result = ' . $registrar . '_unlockdomain($params);');

		if($result["status"]=="2"){
			$dmsg = LOCKOK;
			$dmsg = generate_dmsg($dmsg,"success");
			$req=sqlwritesingle("UPDATE domainlist SET locked='0' WHERE tld='$cTld' AND sld='$realdomain'");
                        $reglocked="0";
		}else{
			$dmsg = "- Failure updating lock status: ".$result["response_text"]." -" ;
			$dmsg = generate_dmsg($dmsg,"error");
		}
	}
}

$expd = $this_dom_config['expiredate'];
if(trim($expd) != "" and $expd != NULL and $expd != "0"){
	$ExpDate = strftime ($date_short, $expd);
}

if($ExpDate == ""){
	$orderid = $this_dom_config['domainid'];
	$ownerid = $this_dom_config['ownerid'];
	$params=array();
	reset($params);
	$params['this_registrar_config']=$this_registrar_config;
	$params['ownerid']=$ownerid;
	$params['cTld']=$cTld;
	$params['cSld']=$cSld;
	$params['realdomain']=$realdomain;
	$params['idn']=$idn;
	$params['idnname']=$idnname;
	$params['idndomain'] = "$idnname.$cTld";
	$params['domain']="$realdomain.$cTld";
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	eval ('$result = ' . $registrar . '_getinfo($params);');

	$ExpDate = $result["expiredate"];
	if($ExpDate == ""){
		$ExpDate = "Currently Unknown";
	}else{
		$expdate=$ExpDate;
		$ExpDate = strftime ($date_short, $expdate);
		$req=sqlwritesingle("UPDATE domainlist SET expiredate='$expdate' WHERE tld='$cTld' AND sld='$realdomain'");
	}
}

if ( $reglocked == "1"){
	$rlchecked="checked";
}
$lockline = "<input type=\"checkbox\" name=\"reglocker\" value=\"yes\" $rlchecked>".DOMLOCKINGCHECKBOX."";

if($autorenewflag=="1"){
	$archecked="checked";
}
$renewline = "<input type=\"checkbox\" name=\"autorenewflag\" value=\"1\" $archecked>".AUTORENEWENABLED."";

$f1_state=0;$f6_state=0;$f5_state=0;
$f1_state=$this_dom_config['f1'];
$f2_state=$this_dom_config['f2'];
$f3_state=$this_dom_config['f3'];
$f6_state=$this_dom_config['f6'];
$f5_state=$this_dom_config['f5'];


$pluginMode = strtolower(trim($_REQUEST['plugin_mode']));

// If we going to show private whois form then we need to check first what is current status for that form
if($pluginMode == 'privatewhois' && $f6_state == 1) {
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	
	$params = array(
		'domain' => $domainName,
		'this_registrar_config'=>$this_registrar_config,
	);

	eval ('$return = ' . $registrar . '_getinfo($params);');
	
	$currentPrivateWhoisStatus = null;
	
	// Check if we have information about current private whois status
	if(isset($return['api']['privatewhois']))	{
		
		// Check if private whois have one of possible values
		$currentStatus = trim(strtolower($return['api']['privatewhois']));
		
		$pwhStatusMap = array(
			'full'     => 'full',
			'partial'  => 'partial',
			'disabled' => 'disable',
		);
		
		$currentPrivateWhoisStatus = isset($pwhStatusMap[$currentStatus]) ? $pwhStatusMap[$currentStatus] : null;
	}
	if(is_null($currentPrivateWhoisStatus))	{
		$dmsg = generate_dmsg('Enable/Disable Private WHOIS is not supported for'.$domainName,"error");
	}
}



// If we going to show a email list managment
if($pluginMode == 'emailfwd' && $f1_state == 1) {
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	
	$params = array(
		'domain' => $domainName,
		'this_registrar_config'=>$this_registrar_config,
	);

	eval ('$return = ' . $registrar . '_getemailfwdlist($params);');
	
	
	$emailFwdList = array();
	$apiResponse = $return['api'];
	
	$index = 1;
	
	while(isset($apiResponse['rule_'.$index.'_source']) && isset($apiResponse['rule_'.$index.'_destination']))	{
		$emailFwdList[] = array($apiResponse['rule_'.$index.'_source'], $apiResponse['rule_'.$index.'_destination']);
		$index++;
	}
}

if($pluginMode == 'urlfwd' && $f2_state == 1) {
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	
	$params = array(
		'domain' => $domainName,
		'this_registrar_config'=>$this_registrar_config,
	);

	eval ('$return = ' . $registrar . '_geturlfwdlist($params);');


	$urlFwdList = array();
	$apiResponse = $return['api'];
	
	$index = 1;
	
	while(isset($apiResponse['rule_'.$index.'_source']) && isset($apiResponse['rule_'.$index.'_destination']))	{
		$urlFwdList[] = array(
			$apiResponse['rule_'.$index.'_source'],
			$apiResponse['rule_'.$index.'_destination'],
			$apiResponse['rule_'.$index.'_isframed'],
			$apiResponse['rule_'.$index.'_title'],
			$apiResponse['rule_'.$index.'_keywords'],
			$apiResponse['rule_'.$index.'_description'],
		);
		
		$index++;
	}
}

if($pluginMode == 'dnsmng' && $f3_state == 1) {
	include_once WORKDIR."/includes/$registrar/".$registrar."v3.php";
	
	$domainName = $cSld.'.'.$cTld;
	
	$params = array(
		'domain' => $domainName,
		'this_registrar_config'=>$this_registrar_config,
	);

	eval ('$return = ' . $registrar . '_getdnsrecordlist($params);');

	$dnsList = array();
	$apiResponse = $return['api'];
	
	$index = 0;
	
	while(isset($apiResponse['records_'.$index.'_name']) && isset($apiResponse['records_'.$index.'_value']))	{
		
		if(strtolower($apiResponse['records_'.$index.'_type']) != 'ns')	{
			$dnsList[] = array(
				$apiResponse['records_'.$index.'_name'],
				$apiResponse['records_'.$index.'_value'],
			
				$apiResponse['records_'.$index.'_ttl'],
				$apiResponse['records_'.$index.'_type'],
				isset($apiResponse['records_'.$index.'_priority']) ? $apiResponse['records_'.$index.'_priority'] : null,
			);
		}
		
		$index++;
	}
}
?>